<?php

/**
 * @file
 * Contains \Drupal\smallads\Form\PreAddForm.
 */

namespace Drupal\smallads\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Routing\RedirectDestinationTrait;
use Drupal\Core\Routing\UrlGeneratorTrait;
use Drupal\Core\Form\FormBase;

/**
 * Form controller for the user password forms.
 */
class PreAddForm extends FormBase {

  use UrlGeneratorTrait;
  use RedirectDestinationTrait;

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'smallads_preadd';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    foreach (smallads_get_types(TRUE) as $tid => $term) {
      $options[$tid] = $term->label();
    }
    $form['type'] = [
      '#title' => $this->t('Type'),
      '#type' => 'radios',
      '#options' => $options,
      '#required' => TRUE,
      '#weight' => 1
    ];
    $form['strapline'] = [
      '#type' => 'textfield',
      '#placeholder' => t('Strapline....'),
      '#weight' => 2,
      '#size' => 15//needs to be fixed with css to 100%
    ];
    $form['actions'] = [
      '#type' => 'actions',
      'submit' => [
        '#type' => 'submit',
        '#value' => t('Next'),
      ],
      '#weight' => 3
    ];
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $values = $form_state->getValues();
    $form_state->setRedirect(
      'smallads.add',
      ['taxonomy_term' => $values['type']],
      ['query' => ['strapline' => $values['strapline']]]
    );
  }

}

