<?php

/**
 * @file
 * Contains \Drupal\smallads\Plugin\Derivative\SmallAdTasks.
 */

namespace Drupal\smallads\Plugin\Derivative;

use Drupal\Core\Plugin\Discovery\ContainerDeriverInterface;
use Drupal\Component\Plugin\Derivative\DeriverBase;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Provides local action definitions to create a wallet for all entities of types configured.
 */
class SmallAdTasks extends DeriverBase implements ContainerDeriverInterface {

  var $derivatives = [];
  var $termStorage = [];

  /**
   * {@inheritDoc}
   *
   */
  public function __construct($termStorage) {
    $this->termStorage = $termStorage;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, $base_plugin_id) {
    return new static(
      $container->get('entity.manager')->getStorage('taxonomy_term')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function getDerivativeDefinitions($base_plugin_definition) {return [];
    $terms = smallads_get_types(TRUE);
    $parent_id = 'view.ads_by_category.page_all';
    //this is the default task
    $first_term = array_shift($terms);
    $this->derivatives[$parent_id .'.all'] = [
      'title' => $first_term->label(),//how to translate this? title callback?
      'base_route' => $parent_id,
      'route_name' => $parent_id,
      'route_parameters' => ['arg_0' => $first_term->tid->value],
      'weight' => -1,
    ] + $base_plugin_definition;
    //mdump($terms);die();
    foreach ($terms as $tid => $term) {
      $this->derivatives[$parent_id .'.'. $term->tid->value ] = [
        'title' => $term->label(),
        'base_route' => $parent_id,
        'route_name' => $parent_id.'.'.$term->tid->value,
        'route_parameters' => ['arg_0' => $term->tid->value],
        //'weight' => $term->weight->value,
      ] + $base_plugin_definition;
    }
    //print_r($this->derivatives);die();
    return $this->derivatives;
  }
}
