<?php

/**
 * @file
 * Contains \Drupal\mcapi\Routing\RouteSubscriber.
 * Creates walletAdd routes for specified entities
 */

namespace Drupal\smallads\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\Route;
use Symfony\Component\Routing\RouteCollection;

/**
 * Subscriber for views routes, one for each argument combindation
 * This is necessary for the links and more importantly the autogenerated tasks
 * Seems like a shortcoming in the routing system, but it will certainly do for this module
 */
class RouteSubscriber extends RouteSubscriberBase {

  private $taxonomyStorage;

  //I don't know where this is injected
  function __construct($entityManager) {
    $this->taxonomyStorage = $entityManager->getStorage('taxonomy_term');
  }

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    foreach (smallads_get_types(TRUE) as $type_term) {
      $tid = $type_term->id();
      $route = (new Route('/ads/'.$tid))
        ->setDefaults([
          '_controller' => 'Drupal\views\Routing\ViewPageController::handle',
          'view_id' => 'ads_by_category',
          'display_id' => 'page_all',
          'arg_0' => $tid,
          //'arg_1' => NULL
        ])
        ->setRequirement('_permission', 'post ad');
      $collection->add('view.ads_by_category.page_all.'.$tid, $route);
/*
      foreach ($this->taxonomyStorage->loadTree('smallad2') as $subcat) {
        $route = (new Route('/ads/'.$type_term->id().'/'.$subcat->tid))
          ->setDefaults([
            '_controller' => 'Drupal\views\Routing\ViewPageController::handle',
            'view_id' => 'ads',
            'display_id' => 'page_all',
            'arg_0' => $type_term->id(),
            'arg_1' => $subcat->tid
          ])
          ->setRequirement('_permission', 'post ad');
        $collection->add($name.'.'.$subcat->tid, $route);
      }
 *
 */
    }
  }

}
