<?php

/**
 * @file
 * Definition of Drupal\smallads\SmallAdViewBuilder.
 */

namespace Drupal\smallads;

use Drupal\Core\Entity\EntityViewBuilder;
use Drupal\Core\Url;

/**
 * Render controller for wallets.
 */
class SmallAdViewBuilder extends EntityViewBuilder {

  /*
   * add the links
   * @todo call this link builder
   */
  function links(&$build, $view_mode, $lang) {
    if ($build['#node']->type != 'proposition') return;
    //add the links
    $node = isset($build['smallads_types']['#object']) ? $build['smallads_types']['#object'] : $build['#node'];
    $owner = user_load($node->uid);
    $ownername = strip_tags(theme('username', array('account' => $owner)));

    if (user_access('access user profiles')) {
      if (module_exists('contact') && function_exists('_contact_personal_tab_access')) {
         $build['links']['node']['#links']['contact'] = array(
          'title' => t('Send an email to !name', array('!name' => $ownername)),
          'href' => "user/$owner->uid/contact",
        );
      }
      $build['links']['node']['#links']['propositions'] = array(
        'title' => t("!name's @types", array('!name' => $ownername, '@type' => node_type_get_type($node)->name)),
        'href' => "user/$owner->uid/propositions",
      );
      $build['links']['node']['#links']['userprofile'] = array(
        'title' => t("See !name's profile", array('!name' => $ownername)),
        'href' => "user/$owner->uid",
      );
    }
    $categories_field = $build['#node']->smallads_categories;
    foreach (element_children($categories_field) as $lang) {
      foreach (element_children($categories_field[$lang]) as $delta) {
        $term = taxonomy_term_load($categories_field[$lang][$delta]['tid']);
        $build['links']['node']['#links']['cat-'.$term->tid] = array(
          'title' => t('See more in !category', array('!category' => $term->name)),
          'href' => ($node->want ? 'wants/' : 'offers/') .$term->tid
        );
      }
    }
    $key = array_search('inline', $build['links']['#attributes']['class']);
    if (is_numeric($key)) unset($build['links']['#attributes']['class'][$key]);
  }

}
