<?php

/**
 * @file
 * Contains \Drupal\smallads\SmallAdViewController.
 */

namespace Drupal\smallads;

use Drupal\Core\Entity\Controller\EntityViewController;
use Drupal\Core\Entity\EntityInterface;
use Drupal\taxonomy\Entity\Term;
use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\Component\Utility\SafeMarkup;

/**
 * Returns responses for smallad routes.
 */
class SmallAdViewController extends EntityViewController {

  public function title(EntityInterface $smallad) {
    return t(
      'Ad: @label',
      [
        '@label' => SafeMarkup::checkPlain(
          $this->entityManager->getTranslationFromContext($smallad)->label()
        )
      ]
    );
  }

  public function addTitle(RouteMatchInterface $routeMatch) {
    if ($term = smallad_valid_type_tid($routeMatch->getParameter('taxonomy_term'))) {
      return t('Create @type', ['@type' => $term->label()]);
    }
  }

  public function editTitle(EntityInterface $smallad) {
    return t('Edit @type', ['@type' => $smallad->type->entity->label()]);
  }

  public function view(EntityInterface $smallad, $view_mode = 'default', $langcode = NULL) {
    //no interference
    $build = parent::view($smallad, $view_mode, $langcode);
    return $build;
  }

}
